#include <stdio.h>
#include <unistd.h>
#include <gst/gst.h>

int main(int argc, char *argv[]) {
  GstElement *pipeline;
  GstElement *myfilter;
  GstBus *bus;
  GstMessage *msg;
  GstCaps *caps;

  /* Initialize GStreamer */
  gst_init (&argc, &argv);

  /* Build the pipeline */
  pipeline = gst_parse_launch ("filesrc location=/home/nvidia/orange_box.h264  ! h264parse ! omxh264dec ! nvvidconv ! capsfilter name=myfilter ! fpsdisplaysink video-sink=xvimagesink", NULL);

  /* Start playing */
  gst_element_set_state (pipeline, GST_STATE_PLAYING);

  /* wait and change scaling */
  sleep(5);
	caps = gst_caps_new_simple ("video/x-raw",
			"width", G_TYPE_INT, 1280,
      "height", G_TYPE_INT, 720, NULL);
  myfilter = gst_bin_get_by_name((GstBin*)pipeline, "myfilter");
  g_object_set (G_OBJECT (myfilter), "caps", caps, NULL);
  gst_caps_unref (caps);


  /* Wait until error or EOS */
  bus = gst_element_get_bus (pipeline);
  msg = gst_bus_timed_pop_filtered (bus, GST_CLOCK_TIME_NONE, GST_MESSAGE_EOS);

  /* Free resources */
  if (msg != NULL)
    gst_message_unref (msg);
  gst_object_unref (bus);
  gst_element_set_state (pipeline, GST_STATE_NULL);
	gst_object_unref (myfilter);
  gst_object_unref (pipeline);
  return 0;
}

